<template>
  <div
    :class="{ 'scrollableOverlay-wrapper': scrollable }"
    v-scroll-lock="scrollable"
    class="wheelsFilters">
    <div
      body-scroll-lock-ignore
      class="filterGroup scrollableOverlay-container">
      <div class="filterGroup-header">
        <div class="heading _h2">
          Фильтры
        </div>
        <button
          @click="$emit('hide')"
          class="filterGroup-close">
          <img
            svg-inline
            src="~/assets/svg/redesign/cross.svg">
        </button>
      </div>

      <div class="filterGroup-item _fluid">
        <div class="filterGroup-field">
          <AppInputRadio
            name="type"
            :value="group"
            @input="$emit('group-change', $event)"
            :list="[
              { label: 'По параметрам', value: $options.filtersGroups.PARAMS },
              { label: 'По автомобилю', value: $options.filtersGroups.AUTO },
          ]"/>
        </div>
        <div class="filterGroup-field buttonResetFilters">
          <AppButton
            @click.native="$emit('reset')"
            :classes="['buttonAsLink', '_light']">
            <template #button-item>Сбросить все</template>
          </AppButton>
        </div>
      </div>

      <!--группа фильтров для подбора ПО ПАРАМЕТРАМ-->
      <template
        v-if="group === $options.filtersGroups.PARAMS">
        <div class="filterGroup-item">
          <div class="filterGroup-field">
            <AppSelect
              :value="model.type"
              :options="values.type"
              id="type"
              track-by="id"
              @select="change"
              @clear="clear('type')"
              :disabled="!values.type.length"
              placeholder="Тип дисков"
              :classes="['_type', 'multiselectThemeSmall']"/>
          </div>

          <div class="filterGroup-field">
            <AppSelect
              :value="model.drill"
              :options="values.drill"
              id="drill"
              track-by="id"
              @select="change"
              @clear="clear('drill')"
              :disabled="!values.drill.length"
              placeholder="Сверловка (PCD)"
              :classes="['_size', 'multiselectThemeSmall']"/>
          </div>

          <div class="filterGroup-field">
            <AppSelect
              :value="model.width"
              :options="values.width"
              id="width"
              track-by="id"
              @select="change"
              @clear="clear('width')"
              :disabled="!values.width.length"
              placeholder="Ширина диска, in"
              :classes="['_size', 'multiselectThemeSmall']"/>
          </div>

          <div class="filterGroup-field">
            <AppSelect
              :value="model.diameter"
              :options="values.diameter"
              id="diameter"
              track-by="id"
              @select="change"
              @clear="clear('diameter')"
              :disabled="!values.diameter.length"
              placeholder="Диаметр диска, in"
              :classes="['_size', 'multiselectThemeSmall']"/>
          </div>

          <div class="filterGroup-field">
            <AppSelect
              :value="model.offset"
              :options="values.offset"
              id="offset"
              track-by="id"
              @select="change"
              @clear="clear('offset')"
              :disabled="!values.offset.length"
              placeholder="Вылет (ET), мм"
              :classes="['_size', 'multiselectThemeSmall']"/>
          </div>

          <div class="filterGroup-field">
            <AppSelect
              :value="model.centerDiameter"
              :options="values.centerDiameter"
              id="centerDiameter"
              track-by="id"
              @select="change"
              @clear="clear('centerDiameter')"
              :disabled="!values.centerDiameter.length"
              placeholder="Диаметр ступицы (DIA), мм"
              :classes="['_sizeBig', 'multiselectThemeSmall']"/>
          </div>

          <div class="filterGroup-field">
            <AppSelect
              :value="model.brand"
              :options="values.brand"
              id="brand"
              track-by="id"
              @select="change"
              @clear="clear('brand')"
              :disabled="!values.brand.length"
              placeholder="Производитель дисков"
              :classes="['_manufacturer', 'multiselectThemeSmall']"/>
          </div>

          <!-- <div class="filterGroup-item _fluid">
            <div class="filterGroup-field">
              <AppCheckbox>
                <template #label>Показать размеры в дюймах</template>
              </AppCheckbox>
              <AppTooltipQuestion
                theme-button="dark"
                placement="right"
                content="Подсказка тут"/>
            </div>
          </div> -->
        </div>
      </template>

      <!--группа фильтров для подбора ПО АВТОМОБИЛЮ-->
      <template v-else>
        <div class="filterGroup-item">
          <div class="filterGroup-field">
            <AppSelect
              :value="model.carManufacturer"
              :options="values.carManufacturer"
              id="carManufacturer"
              track-by="id"
              @select="change"
              @clear="clear('carManufacturer')"
              :disabled="!values.carManufacturer.length"
              placeholder="Марка автомобиля"
              :classes="['_auto', 'multiselectThemeSmall']"/>
          </div>

          <div class="filterGroup-field">
            <AppSelect
              :value="model.carModel"
              :options="values.carModel"
              id="carModel"
              track-by="id"
              @select="change"
              @clear="clear('carModel')"
              :disabled="!values.carModel.length || !model.carManufacturer"
              placeholder="Модель автомобиля"
              :classes="['_auto', 'multiselectThemeSmall']"/>
          </div>

          <div class="filterGroup-field">
            <AppSelect
              :value="model.carYear"
              :options="values.carYear"
              id="carYear"
              track-by="id"
              @select="change"
              @clear="clear('carYear')"
              :disabled="!values.carYear.length || !model.carManufacturer || !model.carModel"
              placeholder="Год выпуска"
              :classes="['_year', 'multiselectThemeSmall']"/>
          </div>

          <div class="filterGroup-field">
            <AppSelect
              :value="model.carType"
              :options="values.carType"
              id="carType"
              track-by="id"
              @select="change"
              @clear="clear('carType')"
              :disabled="!values.carType.length || !model.carManufacturer || !model.carModel || !model.carYear"
              placeholder="Модификация"
              :classes="['_auto', 'multiselectThemeSmall']"/>
          </div>

          <div class="filterGroup-field">
            <AppSelect
              :value="model.brand"
              :options="values.brand"
              id="brand"
              track-by="id"
              @select="change"
              @clear="clear('brand')"
              :disabled="!values.brand.length || !model.carManufacturer || !model.carModel || !model.carYear"
              placeholder="Производитель дисков"
              :classes="['_manufacturer', 'multiselectThemeSmall']"/>
          </div>
        </div>
      </template>

      <div class="filterGroup-item _end-block">
        <div class="filterGroup-field buttonResetFilters">
          <AppButton
            @click.native="$emit('reset')"
            :classes="['buttonAsLink', '_light']">
            <template #button-item>Сбросить все</template>
          </AppButton>
        </div>
      </div>

      <div class="filterGroup-footer">
        <AppButton @click.native="$emit('hide')">
          <template #button-item>
            Показать предложения
          </template>
        </AppButton>
      </div>
    </div>
  </div>
</template>

<script>
import AppSelect from '~/components/redesign/app-select/app-select';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppInputRadio from '~/components/redesign/app-input/app-input-radio';
import AppTooltipQuestion from '~/components/redesign/app-tooltip/app-tooltip-question';
import AppCheckbox from '~/components/redesign/app-input/app-checkbox';

import DisplayStates from '~/assets/js/enums/tyres-wheels-display-states';
import FiltersGroups from '~/assets/js/enums/tyres-wheels-filters-groups';

export default {
  name: 'WheelsFilters',
  components: {
    AppButton,
    AppTooltipQuestion,
    AppCheckbox,
    AppInputRadio,
    AppSelect,
  },
  model: {
    prop: 'model',
    event: 'change',
  },
  props: {
    display: {
      type: String,
      default: DisplayStates.LIST,
    },
    values: {
      type: Object,
      required: true,
    },
    model: {
      type: Object,
      default() {
        return {};
      },
    },
    group: {
      type: String,
      default: FiltersGroups.PARAMS,
    },
    scrollable: {
      type: Boolean,
      default: false,
    },
  },
  created() {
    this.$options.filtersGroups = FiltersGroups;
  },
  methods: {
    change(value = null, filterName) {
      let emitting = { ...this.model, [filterName]: value };

      // убираем фильтры из другой вкладки
      switch (filterName) {
        case 'carManufacturer':
          emitting = {
            ...emitting,
            type: null,
            diameter: null,
            brand: null,
            width: null,
            drill: null,
            offset: null,
            centerDiameter: null,
          };
          break;
        case 'type':
        case 'diameter':
        case 'width':
        case 'drill':
        case 'offset':
        case 'centerDiameter':
          emitting = {
            ...emitting,
            carManufacturer: null,
            carModel: null,
            carYear: null,
            carType: null,
          };
          break;
        default:
      }

      // убираем зависимые фильтры
      switch (filterName) {
        case 'carManufacturer':
          emitting = {
            ...emitting,
            carModel: null,
            carYear: null,
            carType: null,
          };
          break;
        case 'carModel':
          emitting = {
            ...emitting,
            carYear: null,
            carType: null,
          };
          break;
        case 'carYear':
          emitting = {
            ...emitting,
            carType: null,
          };
          break;
        default:
      }

      this.$emit('change', emitting);
    },
    clear(filterName) {
      this.change(null, filterName);
    },
  },
};
</script>

<style lang="postcss">
  .wheelsFilters {
    @media only screen and ( min-width: 981px ) {
      border-top-left-radius: 0;

      .filterGroup {
        transform: translate3d(0,0,0);
        display: flex;
        flex-wrap: wrap;
        padding: 0.25rem 0.625rem;

        &-header {
          display: none;
        }

        &-column {
          display: block;
          padding: 0.5rem 0.5rem 0;
          width: 50%;
        }

        &-item {
          display: flex;
          padding: 0.5rem 0.5rem 0;
          &._fluid {
            width: 100%;
          }
          &._end-block {
            display: none;
          }
        }

        &-field {
          display: inline-flex;
          align-items: center;
          margin: 0 0.375rem 0.5rem;
        }
        &-footer {
          display: none;
        }

        .buttonResetFilters {
          margin-left: auto;
          .button {
            padding: 0.5rem 0 0.5rem 2rem;
            font-size: 0.75rem;
          }
        }

        .inputCheck-label {
          font-size: .75rem;
          color: var(--color-main);
        }
      }
      .multiselect {
        &._type {
          width: 10rem;
          min-width: 10rem;
          max-width: 10rem;
        }

        &._size {
          width: 9.2rem;
          min-width: 9.2rem;
          max-width: 9.2rem;
        }

        &._sizeBig {
          width: 12.5rem;
          min-width: 12.5rem;
          max-width: 12.5rem;
        }

        &._auto {
          width: 11rem;
          min-width: 11rem;
          max-width: 11rem;
        }

        &._year {
          width: 9rem;
          min-width: 9rem;
          max-width: 9rem;
        }

        &._manufacturer {
          width: 11.1rem;
          min-width: 11.1rem;
          max-width: 11.1rem;
        }
      }
    }

    @media only screen and ( max-width: 980px ) {
      border-radius: 0;

      & .filterGroup {
        display: none;
        flex-direction: column;
        position: fixed;
        z-index: var(--z-index-over-modal);
        top: 0;
        bottom: 0;
        left: 0;
        padding: 0 1.25rem;
        width: 100vw;
        height: 100vh;
        background-color: var(--bg-lightest);
        overflow-y: auto;
        overflow-x: hidden;
        &-header {
          z-index: calc(var(--z-index-over-modal) - 1);
          top: 0;
          display: flex;
          justify-content: center;
          align-items: center;
          flex-shrink: 0;
          margin: 0 -1.25rem;
          width: 100vw;
          height: 4.375rem;
          background-color: var(--bg-main);
          border-bottom: 1px solid var(--border-color-main);
        }
        &-close {
          position: absolute;
          top: 0;
          right: 0;
          display: flex;
          align-items: center;
          justify-content: center;
          width: 3.75rem;
          height: 3.75rem;
          background: none;
          border: none;
          box-shadow: none;

          .svg {
            width: 1.25rem;
            height: 1.25rem;
            fill: var(--fill-light);
          }
        }
        &-item, &-column {
          display: block;
          padding: 1.25rem 0;
          width: 100%;
          border-bottom: 1px solid var(--border-color-main);
          .buttonResetFilters {
            display: none;
          }
          &._end-block {
            display: block;
            border-bottom: none;
            .buttonResetFilters {
              display: block;
              .button {
                font-size: 0.875rem;
              }
            }
          }
        }
        &-footer {
          display: flex;
          justify-content: center;
          align-items: flex-start;
          flex-shrink: 1;
          margin:  0 -1.25rem;
          padding: 1rem 1.25rem calc(2rem + var(--mobile-browser-bar));
          width: 100vw;
          height: 100%;
          min-height: 7rem;
          background-color: var(--bg-main);
          border-top: 1px solid var(--border-color-main);
          .button {
            width: 100%;
          }
        }
        .filterGroup-field + .filterGroup-field {
          margin-top: 1.25rem;
        }
      }

      &.-open-in-mobile {
        .filterGroup {
          display: flex;
        }
      }
    }
  }
</style>
